/*
   f98fp.h for f98fp.c
   Funge-98 Fingerprints - header.
   v0.98 Oct 1 1998 Chris Pressey
   Copyunder (u)1998 Cat's-Eye Technologies, http://www.cats-eye.com/
   See http://www.cats-eye.com/license/ for license information.
*/

#ifndef _F98FP_H_
#define _F98FP_H_

extern cell get_fingerprint(ip * i);

#ifndef FBBI_MINIMAL

/* save the semantics of instruction c */
extern void save_semantics(ip * i, char c);

/* restore the last saved semantics of c */
extern void restore_semantics(ip * i, char c);

/* bind c to b() */
extern void bind_semantics(ip * i, char c, void (*b)(ip *));

/* save c, bind c to b() */
extern void overload_semantics(ip * i, char c, void (*b)(ip *));

/* load a fingerprint */
extern int  fingerprint_semantics(ip * i, cell fp, int load);

#endif

#endif /* _F98FP_H_ not defined */
